unit mainu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, MPlayer, StdCtrls, ExtDlgs,jpeg,inifiles,
  math,mmsystem,xpman;

const
  _debugok=false;

  _inifn='MediaPanalyzer.ini';
  _object_height=150;
  _cr=#13#10;
  _about=
    'MediaPanelyzer V1.0 von Daniel Schwamm, Januar 2009'+_cr+_cr+
    'Rechte Maustaste fr Kontext-Men'+_cr+_cr+
    '---------------------------------------------------'+_cr+
    'http://www.daniel-schwamm.de';

  //maximal number of tmediap objects
  _mp_max=200;

  //***********************************************************************
  //TMovP
  //***********************************************************************
  _mov_sound               = $0873;
  _mov_sound_volume        = $4002;
  _mov_sound_item          = $00800000;
  _mov_sound_value         = $01000000;
  _mov_sound_status_volume = $4019;

type
  //***********************************************************************
  //TMovP
  //***********************************************************************
  //record for movie-sound-parameters
  tmov_sound_params=record
    dwCallback:DWORD;
    dwItem:DWORD;
    dwValue:DWORD;
    dwOver:DWORD;
    lpstrAlgorithm:PChar;
    lpstrQuality:PChar;
  end;

  //Movie-Panel-Class
  TMovP=class(tpanel)
  public
    video:tmediaplayer;  //mediaplayer
    displayp:tpanel;     //diplay-panel for video
    ctrlp:tpanel;        //control-panel with buttopns+scrollbar
    startb:tbutton;      //start-button
    haltb:tbutton;       //stop-button
    sb:tscrollbar;       //scrollbar for seek in video
    sb_t:ttimer;         //timer to update scrollbar
    hint_len:string;     //hint: length of video
    hint_frames:string;  //hint: number of frames of video

    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    procedure resize;override;
    procedure startbClick(Sender: TObject);
    procedure haltbClick(Sender: TObject);
    procedure sb_tTimer(Sender: TObject);
    procedure sbScroll(
      Sender:TObject;
      ScrollCode:TScrollCode;
      var ScrollPos:Integer
    );
    procedure Volume_set(Volume:Integer);
    function Volume_get:Integer;
    function open(fn:string):bool;
  end;

  //***********************************************************************
  //TMediaP: Media-Panel, contains image (img) or movie-panel (movp)
  //***********************************************************************
  tmediap=class(tpanel)
  public
    afn:string;      //filename of media

    //strings, necessary for design-sort
    ds_alpha:string;
    ds_size:string;
    ds_chrono:string;

    img:timage; //image-holder
    movp:tmovp; //movie-holder
    sh:tshape;  //active-border-shape

    //original dimension of media
    sz_org_width,
    sz_org_height:integer;

    //aspect ration: height/width
    sz_aspect:double;

    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    procedure resize;override;
    procedure event_MouseDown(
      Sender:TObject;
      Button:TMouseButton;
      Shift:TShiftState;
      X,Y:Integer
    );
    procedure event_MouseMove(
      Sender:TObject;
      Shift:TShiftState;
      X,Y:Integer
    );
    procedure sz_set(v:integer;heightok:bool);
    function open(fn:string):bool;
  end;


  //***********************************************************************
  //THauptF: contains a dynamic collection of tmediap
  //***********************************************************************

  //design sort types
  tdesignsort=(_ds_alpha,_ds_chrono,_ds_size,_ds_random,_ds_opt);

  Tmainf = class(TForm)
    pm: TPopupMenu;
    objects_openpicdlg: TOpenPictureDialog;
    design_sort_lb: TListBox;
    bordersplitter: TSplitter;
    borderp: TPanel;
    sh_t: TTimer;
    design_backgroundcolordlg: TColorDialog;
    collection_OpenDlg: TOpenDialog;
    collection_SaveDlg: TSaveDialog;
    collection_img_savepicdlg: TSavePictureDialog;
    startt: TTimer;

    //menu active object
    aobject1: TMenuItem;
    aobject_mov_start1: TMenuItem;
    aobject_mov_halt1: TMenuItem;
    aobject_mov_sound1: TMenuItem;
    aobject_separator1: TMenuItem;
    aobject_sz_aspect1: TMenuItem;
    aobject_sz_org1: TMenuItem;
    aobject_separator2: TMenuItem;
    aobject_close1: TMenuItem;

    //menu objects
    objects: TMenuItem;
    objects_open1: TMenuItem;
    objects_separator1: TMenuItem;
    objects_movs_start1: TMenuItem;
    objects_movs_halt1: TMenuItem;
    objects_movs_sound1: TMenuItem;
    objects_separator2: TMenuItem;
    objects_sz_aspect1: TMenuItem;
    objects_sz_org1: TMenuItem;
    objects_sz_aspect_height1: TMenuItem;
    objects_sz_aspect_width1: TMenuItem;
    objects_separator3: TMenuItem;
    objetcs_adapt_right1: TMenuItem;
    objetcs_adapt_bottom1: TMenuItem;
    objetcs_adapt_right_bottom1: TMenuItem;
    objects_separator4: TMenuItem;
    objects_close1: TMenuItem;

    separator1: TMenuItem;

    //menu design
    Design1: TMenuItem;
    design_sort_alpha1: TMenuItem;
    design_sort_chrono1: TMenuItem;
    design_sort_size1: TMenuItem;
    design_sort_random1: TMenuItem;
    design_sort_opt1: TMenuItem;
    design_separator1: TMenuItem;
    design_sz_plus1: TMenuItem;
    design_sz_plus_small1: TMenuItem;
    design_sz_minus1: TMenuItem;
    design_sz_minus_small1: TMenuItem;
    design_separator2: TMenuItem;
    design_borderline1: TMenuItem;
    design_backgroundcolor1: TMenuItem;

    //menu collection
    collection1: TMenuItem;
    collection_open1: TMenuItem;
    collection_save1: TMenuItem;
    collection_saveunder1: TMenuItem;
    collection_separator1: TMenuItem;
    collection_img_make1: TMenuItem;
    collection_screenshot_make1: TMenuItem;

    //menu rest
    history1: TMenuItem;
    separator2: TMenuItem;
    about1: TMenuItem;
    separator3: TMenuItem;
    close1: TMenuItem;

    //form and service
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClick(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure sh_tTimer(Sender: TObject);
    procedure pmPopup(Sender: TObject);

    //active object
    procedure aobject_close1Click(Sender: TObject);
    procedure aobject_mov_start1Click(Sender: TObject);
    procedure aobject_mov_halt1Click(Sender: TObject);
    procedure aobject_mov_sound1Click(Sender: TObject);
    procedure aobject_sz_aspect1Click(Sender: TObject);
    procedure aobject_sz_org1Click(Sender: TObject);
    procedure objects_movs_sound1Click(Sender: TObject);

    //objects
    procedure objects_open1Click(Sender: TObject);
    procedure objects_close1Click(Sender: TObject);
    procedure objects_movs_start1Click(Sender: TObject);
    procedure objects_movs_halt1Click(Sender: TObject);
    procedure objects_sz_org1Click(Sender: TObject);
    procedure objects_sz_aspect1Click(Sender: TObject);
    procedure objects_sz_aspect_width1Click(Sender: TObject);
    procedure objects_sz_aspect_height1Click(Sender: TObject);
    procedure objetcs_adapt_right1Click(Sender: TObject);
    procedure objetcs_adapt_bottom1Click(Sender: TObject);
    procedure objetcs_adapt_right_bottom1Click(Sender: TObject);

    //design
    procedure design_sort_alpha1Click(Sender: TObject);
    procedure design_sort_chrono1Click(Sender: TObject);
    procedure design_sort_size1Click(Sender: TObject);
    procedure design_sort_random1Click(Sender: TObject);
    procedure design_sort_opt1Click(Sender: TObject);
    procedure design_sz_plus1Click(Sender: TObject);
    procedure design_sz_plus_small1Click(Sender: TObject);
    procedure design_sz_minus1Click(Sender: TObject);
    procedure design_sz_minus_small1Click(Sender: TObject);
    procedure design_borderline1Click(Sender: TObject);

    //collection
    procedure collection_open1Click(Sender: TObject);
    procedure collection_save1Click(Sender: TObject);
    procedure collection_saveunder1Click(Sender: TObject);
    procedure design_backgroundcolor1Click(Sender: TObject);
    procedure collection_img_make1Click(Sender: TObject);
    procedure collection_screenshot_make1Click(Sender: TObject);

    //rest
    procedure about1Click(Sender: TObject);
    procedure close1Click(Sender: TObject);
    procedure starttTimer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    homedir:string;          //homedir of application
    collection_afn:string;   //filename of active collection
    collection_chgok:bool;   //any changes on collection?
    amp:tmediap;             //active mediap (or NIL)
    design_sort_down:bool;   //design sort direction
    object_height:integer;   //actual standard-height of objects

    //2-dimensional mediap-array for arrangements
    mp_a:array[0.._mp_max,0.._mp_max]of TMediaP;

    //service
    function is_pic(fn:string):bool;
    function is_mov(fn:string):bool;
    function str_fill(s:string;len:integer):string;
    procedure mp_a_clr;
    procedure sh_off;
    procedure info(s:string);
    procedure error(s:string);

    //object(s)
    function object_open(fn:string):bool;
    procedure object_close(mp:tmediap);
    procedure objects_close;

    //design
    procedure design_sz(zoom:double);
    procedure design_arrange;
    procedure design_sort(ds:tdesignsort);

    //collection
    procedure collection_open(fn:string);
    procedure collection_save(fn:string);
    procedure collection_img_thumb(Src,Dst:TBitmap);
    function collection_chgok_chksave:bool;

    //history
    procedure history_go1click(sender:tobject);
  end;

var
  mainf: Tmainf;

implementation

uses coldimu;

{$R *.dfm}

//***********************************************************************
//TMovP
//***********************************************************************
constructor TMovP.Create(AOwner:TComponent);
const
  _bdim=18;
begin
  inherited;

  //little border needed for shape
  left:=2;
  top:=2;
  BevelInner:=bvnone;
  BevelOuter:=bvnone;

  //create movie-control-panel as child of movp
  ctrlp:=tpanel.create(self);
  ctrlp.BevelInner:=bvnone;
  ctrlp.BevelOuter:=bvnone;
  ctrlp.Align:=albottom;
  ctrlp.height:=_bdim+2;
  ctrlp.ParentBackground:=false;
  ctrlp.Color:=clsilver;
  ctrlp.Parent:=self;

  //movie-start-button on ctrlp
  startb:=tbutton.Create(self);
  startb.left:=1;
  startb.top:=1;
  startb.width:=_bdim;
  startb.Height:=_bdim;
  startb.caption:='S';
  startb.hint:='Start';
  startb.onclick:=startbclick;
  startb.parent:=ctrlp;

  //movie-halt-button on ctrlp
  haltb:=tbutton.Create(self);
  haltb.left:=1+_bdim+1;
  haltb.top:=1;
  haltb.width:=_bdim;
  haltb.Height:=_bdim;
  haltb.caption:='H';
  haltb.hint:='Halt';
  haltb.onclick:=haltbclick;
  haltb.enabled:=false; //movie is not running after create
  haltb.parent:=ctrlp;

  //movie-scrollbar on ctrlp
  sb:=tscrollbar.Create(self);
  sb.left:=1+_bdim+1+_bdim+1;
  sb.top:=2;
  sb.height:=_bdim-4;
  sb.OnScroll:=sbscroll;
  sb.parent:=ctrlp;

  //the scrollbar-timer
  sb_t:=ttimer.Create(self);
  sb_t.Interval:=100;
  sb_t.enabled:=false;
  sb_t.ontimer:=sb_ttimer;

  //movie-display-panel as child of movp
  displayp:=tpanel.Create(self);
  displayp.BevelInner:=bvnone;
  displayp.BevelOuter:=bvnone;
  displayp.align:=alclient;
  displayp.ParentBackground:=false;
  displayp.Color:=clblack;
  displayp.parent:=self;

  //create tmediaplayer
  video:=tmediaplayer.create(self);
  video.Shareable:=true;
  video.Visible:=false;
  video.Parent:=self;
end;

destructor tmovp.Destroy;
begin
  haltbclick(nil);
  video.free;
  startb.Free;
  haltb.Free;
  sb.Free;
  sb_t.free;
  ctrlp.free;
  displayp.free;
  inherited;
end;

//movp is resizing
procedure tmovp.resize;
var
  rec:trect;
begin
  inherited;

  //adapt size of movie-display-panel
  rec.top:=0;
  rec.left:=0;
  rec.right:=displayp.width;
  rec.bottom:=displayp.height;
  video.displayrect:=rec;

  //adapt size of scrollbar
  sb.width:=ctrlp.width-(haltb.left+haltb.width)-5;
end;

procedure Tmovp.sb_tTimer(Sender: TObject);
begin
  //avoid positioning while scrolling
  if sb_t.tag<>0 then exit;

  try
    sb.Position:=video.position;
    //video reach end?
    if sb.position>=sb.max-1 then begin
      //start playing again
      video.rewind;
      sb.Position:=0;
      startbClick(sender);
    end;
  except
  end;
end;

//scrolling of scrollbar
procedure Tmovp.sbScroll(
  Sender:TObject;
  ScrollCode:TScrollCode;
  var ScrollPos:Integer
);
var
  i:integer;
begin
  //mark scrolling for sb_t
  sb_t.tag:=1;

  //seek video and scrollbar to scroll-position
  i:=scrollpos;
  if i<0 then i:=0;
  if i>=video.length then i:=video.length-1;
  sb.Position:=i;
  video.position:=i;

  //scrolling ready?
  if scrollcode=scEndScroll then begin
    //mark end of scrolling
    sb_t.tag:=0;

    //run movie if it is not stopped
    if sb_t.enabled then begin
      //avoid strange exception if video reach end
      if i<sb.Max then startbclick(sender);
    end;
  end;
end;

//start-button: play movie
procedure tmovp.startbClick(Sender: TObject);
begin
  if video=nil then exit;
  try
    video.Play;
    sb_t.tag:=0;
    sb_t.enabled:=true;
    startb.Enabled:=false;
    haltb.Enabled:=true;
  except
  end;
end;

//halt-button: stop movie
procedure tmovp.haltbClick(Sender: TObject);
begin
  if video=nil then exit;
  sb_t.enabled:=false;
  startb.Enabled:=true;
  haltb.Enabled:=false;
  try
    video.stop;
  except
  end;
end;

//get sound volume, range 0-1000
function tmovp.Volume_get:Integer;
var
  p:MCI_STATUS_PARMS;
begin
  result:=0;if video=nil then exit;
  p.dwCallback:=0;
  p.dwItem:=_mov_sound_volume;
  mciSendCommand(
    video.DeviceID,
    MCI_STATUS,
    MCI_STATUS_ITEM,
    Cardinal(@p)
  );
  Result:=p.dwReturn;
end;

//Set Volume, range 0-1000
procedure tmovp.Volume_set(Volume:Integer);
var
  map:tmov_sound_params;
begin
  if video=nil then exit;
  map.dwCallback:=0;
  map.dwItem:=_mov_sound_volume;
  map.dwValue:=Volume;
  map.dwOver:=0;
  map.lpstrAlgorithm:=nil;
  map.lpstrQuality:=nil;
  mciSendCommand(
    video.DeviceID,
    _mov_sound,
    _mov_sound_value or _mov_sound_item,
    Cardinal(@map)
  );
end;

//open a movie-file
function tmovp.open(fn:string):bool;
begin
  result:=false;
  try
    video.FileName:=fn;
    video.Display:=displayp;
    video.Open;

    //show first movie-frame
    video.Step;
    video.Previous;

    //set movie-scrollbar parameters
    sb.position:=0;
    sb.Max:=video.length;

    //set hint-infos
    video.TimeFormat:=tfmilliseconds;
    hint_len:='Filmdauer: '+inttostr(round(video.Length/1000))+' Sekunden';
    video.TimeFormat:=tfframes;
    hint_frames:='Anzahl Frames: '+inttostr(video.Length);

    result:=true;
  except
    mainf.error('Keine gltige Movie-Datei: '+fn);
  end;
end;

//***********************************************************************
//TMediaP
//***********************************************************************
constructor tmediap.Create(AOwner: TComponent);
begin
  inherited;

  parentbackground:=false;color:=clblack;
  bevelouter:=bvnone;

  //random position on mainf
  top:=random(screen.height div 3);
  left:=random(screen.width div 3);

  //set standard-dimension
  width:=mainf.object_height;
  height:=mainf.object_height;

  //clear image- and movie-holder
  img:=nil;
  movp:=nil;

  //create shape for selection
  sh:=tshape.create(self);
  sh.Parent:=self;
  sh.Brush.Style:=bsclear;
  sh.Pen.style:=pssolid;
  sh.Pen.color:=cllime;
  sh.Pen.Width:=2;
  sh.align:=alclient;
  sh.onmousedown:=event_mousedown;
  sh.onmousemove:=event_mousemove;
  sh.Visible:=false;

  onmousedown:=event_mousedown;

  //set new mediap as active object
  mainf.sh_off;
  mainf.amp:=self;

  showhint:=true;
  parent:=mainf;
end;

destructor tmediap.Destroy;
begin
  if sh<>nil then sh.Free;
  if img<>nil then img.Free;
  if movp<>nil then movp.Free;
  inherited;
end;

//resizing of media-panel
procedure tmediap.resize;
begin
  inherited;

  //not a movie? Nothing to do
  if movp=nil then exit;

  //adapt size of mov_p a little smaller than mediap
  //(align=client not possible because of shape-border)
  movp.Height:=clientheight-4;
  movp.width:=clientwidth-4;
end;

procedure tmediap.event_MouseDown(
  Sender:TObject;
  Button:TMouseButton;
  Shift:TShiftState;
  X,Y:Integer
);
const
  _sz_left        = $f001;
  _sz_right       = $f002;
  _sz_top         = $f003;
  _sz_top_left    = $f004;
  _sz_top_right   = $f005;
  _sz_bottom      = $f006;
  _sz_bottom_left = $f007;
  _sz_bottom_right= $f008;
  _sz_move        = $f012;
var
  mp:tmediap;
  cmd,mh,mw:integer;
  cu:tcursor;
begin
  mp:=self;

  //set mediap as active object
  cu:=mp.Cursor;
  mainf.sh_off;
  mainf.amp:=mp;
  mp.Cursor:=cu;
  mp.sh.Visible:=true;

  //right-click? then exit
  if shift=[ssright]then exit;

  //check if mouse is over "size-change-point"
  mh:=mp.height div 2;
  mw:=mp.width div 2;

  //init resizing/positioning of mediap
  cmd:=_sz_move;
  if mp.cursor=crsizenwse then
    if y<mh then cmd:=_sz_top_left else cmd:=_sz_bottom_right
  else if mp.cursor=crsizens then
    if y<mh then cmd:=_sz_top else cmd:=_sz_bottom
  else if mp.cursor=crsizewe then
    if x<mw then cmd:=_sz_left else cmd:=_sz_right
  else if mp.cursor=crsizenesw then
    if y<mh then cmd:=_sz_top_right else cmd:=_sz_bottom_left;
  sendmessage(mp.Handle,wm_syscommand,cmd,0);
end;

procedure tmediap.event_MouseMove(
  Sender:TObject;
  Shift:TShiftState;
  X,Y:Integer
);
var
  mh,mw,ww,hh:integer;
  mp:tmediap;
begin
  //right-click? then exit
  if shift=[ssright]then exit;

  //am i the active object? if not, then exit
  mp:=self;if mainf.amp<>mp then exit;

  //check if mouse is over "size-change-point"
  mh:=mp.height div 2;
  mw:=mp.width div 2;
  ww:=mp.width div 10+1;
  hh:=mp.Height div 10+1;

  if (x<ww)and(y<hh) then
    mp.Cursor:=crSizeNWSE
  else if (x>mw-ww)and(x<mw+ww)and(y<hh) then
    mp.cursor:=crsizens
  else if (x>mp.width-ww)and(y<hh) then
    mp.cursor:=crsizenesw
  else if (x>mp.width-ww)and(y>mh-hh)and(y<mh+hh) then
    mp.cursor:=crsizewe
  else if (x>mp.width-ww)and(y>mp.Height-hh) then
    mp.cursor:=crsizenwse
  else if (x>mw-ww)and(x<mw+ww)and(y>mp.height-hh) then
    mp.cursor:=crsizens
  else if (x<ww)and(y>mp.Height-hh) then
    mp.Cursor:=crSizeNeSw
  else if (x<ww)and(y>mh-hh)and(y<mh+hh) then
    mp.cursor:=crsizewe
  else
    mp.cursor:=crsizeall;

  //set 'calculated' cursor to child-controls
  mp.sh.Cursor:=mp.cursor;
  if mp.movp<>nil then mp.movp.displayp.Cursor:=mp.cursor;
  if mp.img<>nil then mp.img.Cursor:=mp.cursor;

  //refresh (new) aspect ratio
  sz_aspect:=clientheight/clientwidth;
end;

//modify size of media-panel in proportional way
procedure tmediap.sz_set(v:integer;heightok:bool);
var
  ow,oh,cw,ch:integer;
begin
  mainf.collection_chgok:=true;
  if movp<>nil then begin
    //movie: height regards control-height
    ow:=sz_org_width;
    oh:=sz_org_height+movp.ctrlp.Height;
  end
  else begin
    ow:=sz_org_width;
    oh:=sz_org_height;
  end;

  //error dimension
  if (ow=0)or(oh=0) then exit;

  if heightok then begin
    //height is fix, calculate width
    ch:=v;
    cw:=round((ow*(ch))/oh);
  end
  else begin
    //width is fix, calculate height
    cw:=v;
    ch:=trunc((cw*oh)/ow);
  end;

  //set new height
  clientheight:=ch;
  clientwidth:=cw;
  sz_aspect:=ch/cw;
end;

//open a media-file
function tmediap.open(fn:string):bool;
var
  sr:WIN32_FIND_DATA;
  status:thandle;
  t:tfiletime;
  st:tsystemtime;
  dt:tdatetime;
begin
  result:=false;

  if not fileexists(fn) then begin
    mainf.error(
      'Datei'+_cr+_cr+
      '  '+fn+_cr+_cr+
      'existiert nicht (mehr)!'
    );
    exit;
  end;

  //is media a picture?
  if mainf.is_pic(fn) then begin
    try
      //create image as child of tmediap
      img:=timage.create(self);
      img.align:=alclient;
      img.Stretch:=true;
      img.Proportional:=false;
      img.center:=false;
      img.onmousedown:=event_mousedown;
      img.Parent:=self;

      //read the picture
      img.Picture.loadfromfile(fn);

      //save original dimension
      sz_org_width:=img.Picture.Width;
      sz_org_height:=img.Picture.height;

    except
      //something goes wrong
      mainf.error('Keine gltige Bild-Datei: '+fn);
      exit;
    end;
  end
  //is media a movie?
  else if mainf.is_mov(fn) then begin
    movp:=tmovp.Create(self);
    movp.displayp.onmousedown:=event_mousedown;
    movp.displayp.onmousemove:=event_mousemove;
    movp.Visible:=false;
    movp.Parent:=self;

    //open the movie-file, check for success
    if not movp.open(fn) then exit;

    //save original dimension
    movp.Visible:=true;
    sz_org_width:=movp.video.displayrect.Right;
    sz_org_height:=movp.video.displayrect.bottom;

    hint:=movp.Hint;
  end
  else begin
    //unkonw media
    mainf.error('Ungltige Medien-Datei: '+fn);
    exit;
  end;

  //get infos from file for design_sort
  status:=findfirstfile(pchar(fn),sr);
  try
    if status=INVALID_HANDLE_VALUE then exit;

    //norm filename fopr alphabetic sort
    ds_alpha:=ansilowercase(extractfilename(fn));

    //fill size width zeros in front because of size order
    ds_size:=mainf.str_fill(
      inttostr(
        int64(
          int64(sr.nFileSizeHigh*MAXDWORD)+
          sr.nFileSizeLow
        )
      ),
      20
    );

    //file-age in american style because of sort order
    try
      filetimetolocalfiletime(sr.ftLastWriteTime,t);
      filetimetosystemtime(t,st);
      dt:=SystemTimeToDateTime(st);
    except
      dt:=0;
    end;
    ds_chrono:=formatdatetime('yyyymmdd hhnnss',dt);
  finally
    windows.findClose(status);
  end;

  //adapt size of display
  sz_set(mainf.object_height,true);
  sz_aspect:=clientheight/clientwidth;

  //media is okay is okay
  afn:=fn;

  hint:=
    'Datei: '+fn+_cr+
    'Auflsung: '+inttostr(sz_org_width)+' x '+inttostr(sz_org_height)+' Pixel';
  if movp<>nil then begin
    hint:=
      hint+_cr+
      movp.hint_frames+_cr+
      movp.hint_len;
  end;
  hint:=
    hint+_cr+
    '----------------------------------'+_cr+
    'Alpha: '+ds_alpha+_cr+
    'Chrono: '+ds_chrono+_cr+
    'Grsse: '+ds_size+' Bytes';

  resize;
  sh.BringToFront;
  result:=true;
end;

//***********************************************************************
//TMainF
//***********************************************************************

//=== TMainF: FORM & SERVICE ========================================

procedure Tmainf.FormCreate(Sender: TObject);
begin
  homedir:=extractfilepath(application.exename);
  parentbackground:=false;color:=clgray;
  windowstate:=wsmaximized;
  borderstyle:=bsnone;
  borderp.ParentBackground:=false;borderp.Color:=clsilver;

  objects_openpicdlg.Filter:=
    'Bilder (*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf)|'+
    '*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf|'+
    'Movies (*.avi;*.mpg;*.mpeg;*.m1v;*.wmv)|'+
    '*.avi;*.mpg;*.mpeg;*.m1v;*.wmv|'+
    'Alle Dateien (*.*)|*.*';
  objects_openpicdlg.Options:=[ofHideReadOnly,ofAllowMultiSelect,ofFileMustExist,ofEnableSizing];

  //standard-dimension of tmediap
  object_height:=_object_height;

  //cursor control short-cuts
  design_sz_plus1.shortcut:=shortcut(vk_down,[]);
  design_sz_minus1.shortcut:=shortcut(vk_up,[]);
  design_sz_plus_small1.shortcut:=shortcut(vk_right,[]);
  design_sz_minus_small1.shortcut:=shortcut(vk_left,[]);

  startt.enabled:=true;
end;

procedure Tmainf.FormDestroy(Sender: TObject);
var
  inif:tinifile;
begin
  sh_t.enabled:=false;
  deletefile(homedir+_inifn);

  inif:=tinifile.create(homedir+_inifn);
  try
    inif.writestring('param','collection_afn',collection_afn);
    inif.writestring('param','objects_opendlg_dir',objects_openpicdlg.InitialDir);
    inif.writestring('param','collection_opendlg_dir',collection_opendlg.InitialDir);
    inif.writestring('param','collection_savedlg_dir',collection_savedlg.InitialDir);
    inif.writestring('param','collection_img_savepicdlg_dir',collection_img_savepicdlg.InitialDir);
    inif.writeinteger('param','color',color);
  finally
    inif.Free;
  end;

  //free memory
  objects_close;
end;

procedure Tmainf.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if not collection_chgok_chksave then canclose:=false;
end;

procedure Tmainf.starttTimer(Sender: TObject);

  function dir_set(dir:string):string;
  begin
    if directoryexists(dir) then result:=dir
                            else result:=homedir;
  end;

var
  inif:tinifile;
begin
  startt.enabled:=false;

  if not _debugok then about1Click(Sender);

  inif:=tinifile.create(homedir+_inifn);
  try
    collection_afn:=inif.readstring('param','collection_afn','');
    objects_openpicdlg.InitialDir:=dir_set(
      inif.readstring('param','objects_opendlg_dir',homedir)
    );
    collection_opendlg.InitialDir:=dir_set(
      inif.readstring('param','collection_opendlg_dir',homedir)
    );
    collection_savedlg.InitialDir:=dir_set(
      inif.readstring('param','collection_savedlg_dir',homedir)
    );
    collection_img_savepicdlg.InitialDir:=dir_set(
      inif.readstring('param','collection_img_savepicdlg_dir',homedir)
    );
    Color:=inif.ReadInteger('param','color',clgray);
  finally
    inif.Free;
  end;

  //collection to load?
  if collection_afn<>'' then collection_open(collection_afn);

  sh_t.enabled:=true;
end;

procedure Tmainf.FormClick(Sender: TObject);
begin
  //disable active tmedaip
  sh_off;
end;

procedure Tmainf.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  design_sz_plus_small1Click(Sender);
  handled:=true;
end;

procedure Tmainf.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  design_sz_minus_small1Click(Sender);
  handled:=true;
end;

procedure Tmainf.pmPopup(Sender: TObject);
var
  object_ok,mov_ok:bool;
  r:integer;
  mp:tmediap;
begin
  //any movie-mediapanels?
  object_ok:=false;
  mov_ok:=false;
  for r:=componentcount-1 downto 0 do begin
    if not(components[r] is tmediap) then continue;
    mp:=tmediap(components[r]);
    object_ok:=true;
    if mp.movp=nil then continue;
    mov_ok:=true;
    break;
  end;

  //active object
  if amp=nil then aobject1.enabled:=false
  else begin
    aobject1.enabled:=true;
    aobject_mov_start1.Enabled:=(amp.movp<>nil);
    aobject_mov_halt1.Enabled:=(amp.movp<>nil);
    aobject_mov_sound1.Enabled:=(amp.movp<>nil);

    if amp.movp<>nil then begin
      aobject_mov_start1.checked:=amp.movp.sb_t.enabled;
      aobject_mov_halt1.checked:=not aobject_mov_start1.checked;
      aobject_mov_sound1.checked:=(amp.movp.Volume_get>0);
    end;
  end;

  //objects
  objects_movs_start1.enabled:=mov_ok;
  objects_movs_halt1.enabled:=mov_ok;
  objects_movs_sound1.enabled:=mov_ok;

  objects_sz_aspect1.Enabled:=object_ok;
  objects_sz_aspect_width1.enabled:=(amp<>nil);
  objects_sz_aspect_height1.enabled:=(amp<>nil);
  objects_close1.enabled:=object_ok;

  //design
  design_sort_alpha1.Enabled:=object_ok;
  design_sort_chrono1.Enabled:=object_ok;
  design_sort_size1.Enabled:=object_ok;
  design_sort_random1.Enabled:=object_ok;
  design_sort_opt1.Enabled:=object_ok;

  design_sz_plus1.enabled:=object_ok;
  design_sz_plus_small1.enabled:=object_ok;
  design_sz_minus1.enabled:=object_ok;
  design_sz_minus_small1.enabled:=object_ok;

  //collection
  collection_save1.enabled:=object_ok and(collection_afn<>'');
  collection_saveunder1.enabled:=object_ok;
  collection_img_make1.enabled:=object_ok;
  collection_screenshot_make1.enabled:=object_ok;

  //history
  history1.Enabled:=(history1.count>0);
end;

procedure Tmainf.sh_tTimer(Sender: TObject);
begin
  if amp=nil then exit;
  sh_t.Tag:=(sh_t.Tag+1)mod 2;
  if sh_t.tag=0 then amp.sh.Visible:=false
                else amp.sh.visible:=true;
end;

//disable active object
procedure tmainf.sh_off;
var
  r:integer;
  mp:tmediap;
begin
  releasecapture;
  amp:=nil;
  for r:=0 to componentcount-1 do begin
    if not(components[r] is tmediap) then continue;
    mp:=tmediap(components[r]);

    //set standard cursor for mediap and it's child-controls
    mp.Cursor:=crdefault;
    if mp.movp<>nil then mp.movp.displayp.cursor:=crdefault;
    if mp.img<>nil then mp.img.cursor:=crdefault;
    mp.sh.Visible:=false;
  end;
  amp:=nil;
end;

function tmainf.is_pic(fn:string):bool;
begin
  fn:=lowercase(extractfileext(fn));
  result:=
    (fn='.jpg')or(fn='.jpeg')or(fn='.jpe')or
    (fn='.bmp')or(fn='.ico')or(fn='.emf')or(fn='.wmf');
end;

function tmainf.is_mov(fn:string):bool;
begin
  fn:=lowercase(extractfileext(fn));
  result:=
    (fn='.wav')or(fn='.mp3')or(fn='.flv')or(fn='.mp4')or
    (fn='.mpg')or(fn='.mpe')or(fn='.mpeg')or(fn='.avi')or(fn='.mov')or
    (fn='.wmv')or(fn='.m1v')or(fn='.wma')or(fn='.asx')or(fn='.asf');
end;

//clear mediap-array
procedure tmainf.mp_a_clr;
var
  x,y:integer;
begin
  for y:=0 to _mp_max do
    for x:=0 to _mp_max do
      mp_a[x,y]:=nil;
end;

//fill string with previus zeros
function tmainf.str_fill(s:string;len:integer):string;
begin
  while length(s)<len do s:='0'+s;
  result:=s;
end;

procedure tmainf.info(s:string);
begin
  application.MessageBox(pchar(s),'*** HINWEIS ***',mb_ok);
end;

procedure tmainf.error(s:string);
begin
  beep;
  application.MessageBox(pchar(s),'*** FEHLER ***',mb_ok);
end;

//=== TMainF: Active Object ========================================

procedure Tmainf.aobject_mov_start1Click(Sender: TObject);
begin
  if amp=nil then exit;
  if amp.movp=nil then exit;
  amp.movp.startbclick(sender);
end;

procedure Tmainf.aobject_mov_halt1Click(Sender: TObject);
begin
  if amp=nil then exit;
  if amp.movp=nil then exit;
  amp.movp.haltbclick(sender);
end;

procedure Tmainf.aobject_mov_sound1Click(Sender: TObject);
begin
  if amp=nil then exit;
  if amp.movp=nil then exit;
  if aobject_mov_sound1.checked then begin
    amp.movp.volume_set(0);
  end
  else begin
    amp.movp.volume_set(1000);
  end;
end;

procedure Tmainf.aobject_sz_aspect1Click(Sender: TObject);
begin
  if amp=nil then exit;
  amp.sz_set(amp.clientheight,true);
end;

procedure Tmainf.aobject_sz_org1Click(Sender: TObject);
begin
  if amp=nil then exit;
  amp.sz_set(amp.sz_org_height,true);
end;

procedure tmainf.object_close(mp:tmediap);
var
  r:integer;
  found:bool;
  mi:tmenuitem;
begin
  //noch aktives element in verlauf
  //eintrag schon vorhanden?
  found:=false;
  for r:=0 to history1.Count-1 do begin
    if ansilowercase(history1.Items[r].hint)=ansilowercase(mp.afn) then begin
      found:=true;
      break;
    end;
  end;

  if not found then begin
    //nein, dann neu dazu
    mi:=tmenuitem.Create(pm);
    mi.caption:=mp.afn;
    mi.Hint:=mp.afn;
    mi.onclick:=history_go1click;
    history1.Add(mi);
  end;

  mp.free;
  sh_off;
  collection_chgok:=true;

  //any objects for a collection?
  found:=false;
  for r:=0 to componentcount-1 do begin
    if not(components[r] is tmediap) then continue;
    found:=true;
    break;
  end;
  if not found then collection_afn:='';
  bringtofront;
end;

procedure Tmainf.aobject_close1Click(Sender: TObject);
begin
  if amp=nil then exit;
  object_close(amp);
end;

//=== TMainF: Objects ========================================
function Tmainf.object_open(fn:string):bool;
var
  r,object_c:integer;
  mp:tmediap;
begin
  result:=false;

  //movies can open only one time
  if is_mov(fn) then begin
    for r:=0 to componentcount-1 do begin
      if not(components[r] is tmediap) then continue;
      mp:=tmediap(components[r]);
      if ansilowercase(fn)=ansilowercase(mp.afn) then exit;
    end;
  end;

  //count objects
  object_c:=0;
  for r:=0 to componentcount-1 do begin
    if not(components[r] is tmediap) then continue;
    inc(object_c);
  end;

  //reach max number of objects?
  if object_c>=_mp_max-1 then begin
    error(
      'Maximale Anzahl von Objekten erreicht ('+inttostr(_mp_max)+').'+_cr+
      'Neues Objekt '+_cr+_cr+
      '  '+fn+_cr+_cr+
      'nicht generiert!'
    );
    exit;
  end;

  //create new media-panel
  mp:=tmediap.create(self);
  if not mp.open(fn) then begin
    //no media loaded
    mp.free;
    amp:=nil;
    exit;
  end;
  collection_chgok:=true;
  sh_t.Enabled:=true;
  result:=true;
end;

//shape timer: change shape border of active object
procedure Tmainf.objects_open1Click(Sender: TObject);
var
  r:integer;
begin
  if not objects_openpicdlg.execute then exit;
  for r:=0 to objects_openpicdlg.Files.Count-1 do begin
    object_open(objects_openpicdlg.Files[r]);
  end;
  if objects_openpicdlg.Files.Count>0 then
    objects_openpicdlg.initialdir:=extractfilepath(objects_openpicdlg.Files[0]);
end;

procedure Tmainf.objects_movs_start1Click(Sender: TObject);
var
  r:integer;
  mp:tmediap;
begin
  for r:=componentcount-1 downto 0 do begin
    if not(components[r] is tmediap) then continue;
    mp:=tmediap(components[r]);
    if mp.movp<>nil then mp.movp.startbclick(sender);
  end;
end;

procedure Tmainf.objects_movs_halt1Click(Sender: TObject);
var
  r:integer;
  mp:tmediap;
begin
  for r:=componentcount-1 downto 0 do begin
    if not(components[r] is tmediap) then continue;
    mp:=tmediap(components[r]);
    if mp.movp<>nil then mp.movp.haltbclick(sender);
  end;
end;

procedure Tmainf.objects_movs_sound1Click(Sender: TObject);
var
  r:integer;
  mp:tmediap;
begin
  objects_movs_sound1.Checked:=not objects_movs_sound1.checked;
  for r:=componentcount-1 downto 0 do begin
    if not(components[r] is tmediap) then continue;
    mp:=tmediap(components[r]);
    if mp.movp=nil then continue;
    if objects_movs_sound1.Checked then mp.movp.volume_set(1000)
                                   else mp.movp.volume_set(0);
  end;
end;

procedure Tmainf.objects_sz_aspect1Click(Sender: TObject);
var
  r:integer;
  mp:tmediap;
begin
  for r:=componentcount-1 downto 0 do begin
    if not(components[r] is tmediap) then continue;
    mp:=tmediap(components[r]);
    mp.sz_set(mp.clientheight,true);
  end;
end;

procedure Tmainf.objects_sz_org1Click(Sender: TObject);
var
  r:integer;
  mp:tmediap;
begin
  for r:=componentcount-1 downto 0 do begin
    if not(components[r] is tmediap) then continue;
    mp:=tmediap(components[r]);
    mp.sz_set(mp.sz_org_height,true);
  end;
end;

procedure Tmainf.objects_sz_aspect_width1Click(Sender: TObject);
var
  r:integer;
  mp:tmediap;
begin
  if amp=nil then exit;
  for r:=componentcount-1 downto 0 do begin
    if not(components[r] is tmediap) then continue;
    mp:=tmediap(components[r]);
    mp.sz_set(amp.width,false);
  end;
end;

procedure Tmainf.objects_sz_aspect_height1Click(Sender: TObject);
var
  r:integer;
  mp:tmediap;
begin
  if amp=nil then exit;
  for r:=componentcount-1 downto 0 do begin
    if not(components[r] is tmediap) then continue;
    mp:=tmediap(components[r]);
    mp.sz_set(amp.height,true);
  end;
end;

procedure Tmainf.objetcs_adapt_right1Click(Sender: TObject);
var
  xc,y,x,w,sw:integer;
  mp:tmediap;
  wd:double;
begin
  //define the width of one row tmediaps
  sw:=screen.width-2;

  //if there is a right-border then take this as "sw"
  if bordersplitter.Visible then sw:=bordersplitter.Left;

  //check every row of tmediaps
  for y:=0 to _mp_max do begin

    //sum of widths in actual row
    xc:=0;
    w:=0;
    for x:=0 to _mp_max do begin
      if mp_a[x,y]=nil then continue;
      mp:=mp_a[x,y];
      w:=w+mp.Width;
      inc(xc);
    end;

    //at least one tmediap found in row?
    if xc>0 then begin

      //calculate rest of screen to fill
      wd:=sw-w;

      //calculate delta to add to widths
      wd:=wd/xc;

      //increase the width of every tmediap in row
      for x:=0 to _mp_max do begin
        if mp_a[x,y]=nil then continue;
        mp:=mp_a[x,y];

        //modify width and calculate new aspect ratio
        mp.Width:=trunc(mp.Width+wd);
        mp.sz_aspect:=mp.Height/mp.width;
      end;
    end;
  end;

  //show the mediaps with modified widths
  design_arrange;
end;

procedure Tmainf.objetcs_adapt_bottom1Click(Sender: TObject);
var
  t,h,yc,sh,y,x:integer;
  mp:tmediap;
  hd:double;
begin
  //height to fill
  sh:=screen.height;

  //sum of heights
  yc:=0;
  h:=0;
  for y:=0 to _mp_max do begin
    if mp_a[0,y]=nil then continue;
    mp:=mp_a[0,y];
    h:=h+mp.height;
    inc(yc);
  end;

  //calculate rest of screen to fill
  hd:=sh-h;

  //calculate delta to add to heights
  hd:=hd/yc;

  //increase hight of every mediap
  for y:=0 to _mp_max do begin
    //calculate new top of actual row
    t:=trunc(hd*y);
    for x:=0 to _mp_max do begin
      if mp_a[x,y]=nil then continue;
      mp:=mp_a[x,y];
      mp.height:=trunc(mp.height+hd);
      mp.top:=mp.top+t;
      mp.sz_aspect:=mp.Height/mp.width;
    end;
  end;

  //show the mediaps with modified heights
  design_arrange;
end;

procedure Tmainf.objetcs_adapt_right_bottom1Click(Sender: TObject);
begin
  objetcs_adapt_right1Click(Sender);
  objetcs_adapt_bottom1Click(Sender);
end;

procedure Tmainf.objects_close;
var
  r:integer;
begin
  //disbale active object
  sh_t.enabled:=false;
  sh_off;

  //close all tmediap-objects
  for r:=componentcount-1 downto 0 do begin
    if not(components[r] is tmediap) then continue;
    object_close(tmediap(components[r]));
  end;

  //strange behaviour of vista: widthout bringtofront
  //the application move zo background
  mainf.BringToFront;

  //clear collection, remark the change
  collection_afn:='';
  collection_chgok:=true;
end;

procedure Tmainf.objects_close1Click(Sender: TObject);
begin
  if application.messagebox(
    'Wirklich alle Objekte schliessen?',
    '*** FRAGE ***',
    mb_yesno
  )=id_no then
    exit;
  objects_close;
end;


//=== TMainF: Design ========================================

//arrange tmediap-objects in special order
procedure tmainf.design_sort(ds:tdesignsort);
var
  mp:tmediap;
  x,y,sw,rr,r,t,tg,l:integer;
  s:string;
begin
  collection_chgok:=true;
  mp_a_clr;

  //fill listbox with design_sort_strings
  design_sort_lb.clear;
  rr:=0;
  for r:=0 to componentcount-1 do begin
    if not(components[r] is tmediap) then continue;
    mp:=tmediap(components[r]);

    //get design_sort_string
    if      ds=_ds_alpha  then s:=mp.ds_alpha
    else if ds=_ds_chrono then s:=mp.ds_chrono
    else if ds=_ds_size   then s:=mp.ds_size
    else if ds=_ds_random then s:=str_fill(inttostr(random(1000)),10)
    else                       s:=''; //should never happen

    //design_sort_string + object_number in listbox
    design_sort_lb.Items.add(s+'<'+inttostr(rr));

    //save object_number
    mp.tag:=rr;
    rr:=rr+1;
  end;

  //maximal width
  sw:=screen.width;

  //can be left of border-panel
  if borderp.Visible then sw:=bordersplitter.Left;

  //arrange panels on mainf
  x:=0;
  y:=0;
  t:=0;
  l:=0;
  for rr:=0 to design_sort_lb.Items.count-1 do begin

    //sort-direction
    if design_sort_down then
      s:=design_sort_lb.items[design_sort_lb.Items.count-1-rr]
    else
      s:=design_sort_lb.items[rr];

    //filter object_number
    tg:=pos('<',s);
    tg:=strtoint(copy(s,tg+1,length(s)));

    //search object with thar object-number
    for r:=0 to componentcount-1 do begin
      if not(components[r] is tmediap) then continue;
      mp:=tmediap(components[r]);

      //object-number found?
      if mp.tag<>tg then continue;

      //reach right border?
      if (l+mp.width)>sw then begin
        //yep, start new row
        l:=0;
        t:=t+mp.height;

        //increase row-counter
        inc(y);

        //set first col-counter
        x:=0;
      end;

      //set new position
      mp.top:=t;
      mp.left:=l;
      mp_a[x,y]:=mp;

      //calculate next left-position
      l:=l+mp.width;

      //increase col-counter
      inc(x);
      break;
    end;
  end;

  //delete number-tags of all tmediaps
  for r:=0 to componentcount-1 do begin
    if not(components[r] is tmediap) then continue;
    tmediap(components[r]).Tag:=0;
  end;

  //change sort direction next time
  design_sort_down:=not design_sort_down;
end;

procedure Tmainf.design_sort_alpha1Click(Sender: TObject);
begin
  design_sort(_ds_alpha);
end;

procedure Tmainf.design_sort_chrono1Click(Sender: TObject);
begin
  design_sort(_ds_chrono);
end;

procedure Tmainf.design_sort_size1Click(Sender: TObject);
begin
  design_sort(_ds_size);
end;

procedure Tmainf.design_sort_random1Click(Sender: TObject);
begin
  design_sort(_ds_random);
end;

procedure Tmainf.design_sort_opt1Click(Sender: TObject);
const
  _outer_trys_max=50;
  _inner_trys_max=100;
type
  twidth_a=array[0.._mp_max*_mp_max]of integer;

  //search tmedia with width "w"
  function getpanel(w:integer):tmediap;
  var
    r,x,y:integer;
    mp:tmediap;
    foundok:bool;
  begin
    result:=nil;
    for r:=0 to componentcount-1 do begin
      if not(components[r] is tmediap) then continue;
      mp:=tmediap(components[r]);

      //searched width found?
      if mp.width<>w then continue;

      //is tmediap free?
      foundok:=false;
      for y:=0 to _mp_max do begin
        for x:=0 to _mp_max do begin
          if mp_a[x,y]=nil then continue;
          if mp_a[x,y]=mp then foundok:=true;
        end
      end;

      if not foundok then begin
        //yep, it is free
        result:=mp;
        break;
      end;
    end;
  end;

var
  swo,yc,dsw,
  h,t,l,
  outer_trys,inner_trys,
  x,y,errmin,wmax,w,rr,err,sw,r,wc:integer;
  w_a,wold_a,wnew_a:^twidth_a;
  mp:tmediap;
begin
  //create width-arrays
  new(w_a);
  new(wold_a);
  new(wnew_a);

  try

    //get all widths in w_a
    wc:=0;
    for r:=0 to componentcount-1 do begin
      if not(components[r] is tmediap) then continue;
      w_a[wc]:=tmediap(components[r]).width;
      inc(wc);
    end;

    //set error to a big value
    errmin:=screen.width*100;

    //get max width
    sw:=screen.width;
    if bordersplitter.Visible then sw:=bordersplitter.Left;

    //calculate a modifier for max width
    swo:=sw;
    dsw:=(sw-100) div _outer_trys_max;if dsw<0 then dsw:=0;

    //outer loop: makes max width "sw" smaller
    for outer_trys:=0 to _outer_trys_max do begin

      //inner loop: search optimum for given max width
      for inner_trys:=0 to _inner_trys_max do begin

        //save width_array
        for r:=0 to wc-1 do wold_a[r]:=w_a[r];

        //change width_array in random way
        for r:=0 to wc-1 do begin

          //find a free width
          repeat
            rr:=random(wc);
          until wold_a[rr]>0;

          //save founded width
          wnew_a[r]:=wold_a[rr];

          //mark width as ready
          wold_a[rr]:=-1;
        end;

        //get max width of rows
        wmax:=0;
        r:=0;
        repeat
          //fill row, stop if right border is reached
          w:=0;
          repeat
            w:=w+wnew_a[r];
            inc(r);
          until (r>wc-1)or(w+wnew_a[r]>sw);

          if w>wmax then wmax:=w;
        until r=wc;

        //calculate error_sum
        yc:=0;
        err:=0;
        r:=0;
        repeat
          //fill row, stop if right border is reached
          w:=0;
          repeat
            w:=w+wnew_a[r];
            inc(r);
          until (r>wc-1)or(w+wnew_a[r]>sw);
          inc(yc);
          err:=err+(wmax-w);
        until r=wc;

        //modify error-sum: more rows => bigger error
        err:=err+(swo-sw)*yc;

        //new minimum found?
        if err>=errmin then continue;

        //yep
        errmin:=err;

        //save positions in mp_a
        mp_a_clr;
        y:=0;
        r:=0;
        repeat
          //flle zeile bis ber rechten rand
          w:=0;
          x:=0;
          repeat
            w:=w+wnew_a[r];
            mp_a[x,y]:=getpanel(wnew_a[r]);
            inc(r);
            inc(x);
          until (r>wc-1)or(w+wnew_a[r]>sw);
          inc(y);
        until r=wc;
      end;

      //now reduce max width an try again
      sw:=sw-dsw;if sw<100 then sw:=00;
    end;

    //okay, a minum was found and saved in mp_a
    //arrange tmediap-objects new
    h:=0;
    t:=0;
    for y:=0 to _mp_max do begin
      l:=0;
      for x:=0 to _mp_max do begin
        if mp_a[x,y]=nil then continue;
        mp:=mp_a[x,y];
        mp.Top:=t;
        mp.left:=l;
        if l=0 then h:=mp.height;
        l:=l+mp.width;
      end;
      t:=t+h;
    end;

  finally
    //free memory
    dispose(wnew_a);
    dispose(wold_a);
    dispose(w_a);
  end;
end;

//increase/decrease size of tmediap in proportional way
procedure Tmainf.design_sz(zoom:double);
var
  mp:tmediap;
  r:integer;
  ow,oh,d:double;
begin
  collection_chgok:=true;
  for r:=0 to componentcount-1 do begin
    if not(components[r] is tmediap) then continue;

    mp:=tmediap(components[r]);

    //get aspect ratio (height/width) of tmediap
    d:=mp.sz_aspect;

    //zoom the height
    //increase height if zoom>1
    //decrease height if zoom<1
    oh:=mp.height*zoom;

    //use aspect ratio to calulate new width
    ow:=oh/d;

    //setze new dimension
    mp.Height:=trunc(oh);
    mp.width:=trunc(ow);

    //save new height as standard_height
    object_height:=trunc(oh);
  end;

  //arrange tmediap-objects on screen
  design_arrange;
end;

procedure Tmainf.design_sz_plus1Click(Sender: TObject);
begin
  design_sz(1.1);
end;

procedure Tmainf.design_sz_plus_small1Click(Sender: TObject);
begin
  design_sz(1.01);
end;

procedure Tmainf.design_sz_minus1Click(Sender: TObject);
begin
  design_sz(0.9);
end;

procedure Tmainf.design_sz_minus_small1Click(Sender: TObject);
begin
  design_sz(0.99);
end;

procedure tmainf.design_arrange;
type
  tmedia_a=array[0.._mp_max*_mp_max]of tmediap;
var
  hold,sw,r,pc,x,y,l,t:integer;
  mp_tmp_a:^tmedia_a;
  mp:tmediap;
begin
  //create temporary 1-dim mediap-array
  new(mp_tmp_a);
  try

    //fill temporary array as sequenz
    pc:=0;
    for y:=0 to _mp_max do begin
      for x:=0 to _mp_max do begin
        if mp_a[x,y]=nil then continue;
        mp:=mp_a[x,y];
        mp_tmp_a[pc]:=mp;
        inc(pc);
      end;
    end;

    //clear 2-dim mediap-array
    mp_a_clr;

    //max width to arrange
    sw:=screen.width;
    if bordersplitter.Visible then sw:=bordersplitter.Left;

    //replace moveps
    x:=0;
    y:=0;
    hold:=0;
    t:=0;
    l:=0;
    for r:=0 to pc-1 do begin
      mp:=mp_tmp_a[r];

      //reach right border?
      if l+mp.width>sw then begin

       //yep, start new row
       x:=0;
       l:=0;
       t:=t+hold;
       inc(y);
      end;

      //set new position
      mp.Top:=t;
      mp.left:=l;
      mp_a[x,y]:=mp;
      inc(x);

      //calculate new coodinates
      l:=l+mp.width;
      hold:=mp.height;
    end;

  finally
    //memory free
    dispose(mp_tmp_a);
  end;
end;

procedure Tmainf.design_borderline1Click(Sender: TObject);
begin
  design_borderline1.Checked:=not design_borderline1.checked;
  borderp.visible:=design_borderline1.Checked;
  bordersplitter.visible:=design_borderline1.Checked;
end;

procedure Tmainf.design_backgroundcolor1Click(Sender: TObject);
begin
  design_backgroundcolordlg.Color:=color;
  if not design_backgroundcolordlg.Execute then exit;
  color:=design_backgroundcolordlg.Color;
end;

//=== TMainF: Collection ========================================
procedure tmainf.collection_open(fn:string);
var
  inif:tinifile;
  rr:integer;
  mp_a_x,mp_a_y:integer;
begin
  screen.Cursor:=crhourglass;
  objects_movs_halt1Click(Self);

  if not fileexists(fn) then begin
    error(
      'MediaPanelyzer-Kollektion'+_cr+_cr+
      '  '+fn+_cr+_cr+
      'existiert nicht (mehr)!'
    );
    exit;
  end;

  collection_afn:=fn;
  collection_opendlg.initialdir:=extractfilepath(fn);
  collection_savedlg.initialdir:=extractfilepath(fn);

  inif:=tinifile.create(fn);
  try
    mp_a_clr;
    rr:=0;
    repeat
      fn:=inif.readString('mp'+inttostr(rr),'fn','');
      if fn<>'' then begin
        if object_open(fn) then begin
          amp.Top   :=inif.readinteger('mp'+inttostr(rr),'top',   amp.top   );
          amp.left  :=inif.readinteger('mp'+inttostr(rr),'left',  amp.left  );
          amp.height:=inif.readinteger('mp'+inttostr(rr),'height',amp.height);
          object_height:=amp.height;
          amp.width :=inif.readinteger('mp'+inttostr(rr),'width', amp.width );
          amp.sz_aspect:=amp.clientheight/amp.clientwidth;

          //array-pos
          mp_a_x:=inif.readinteger('mp'+inttostr(rr),'mp_a_x',-1);
          mp_a_y:=inif.readinteger('mp'+inttostr(rr),'mp_a_y',-1);
          if(mp_a_x<>-1)and(mp_a_y<>-1)then mp_a[mp_a_x,mp_a_y]:=amp;
        end;
      end;
      inc(rr);
    until fn='';
  finally
    inif.free;
    sh_off;
    collection_chgok:=false;
    screen.Cursor:=crdefault;
    if not _debugok then begin
      info('Kollektion'+_cr+_cr+'  '+collection_afn+_cr+_cr+'geladen');
    end;
  end;
end;

procedure Tmainf.collection_open1Click(Sender: TObject);
begin
  if not collection_chgok_chksave then exit;
  if not collection_opendlg.execute then exit;
  collection_open(collection_opendlg.FileName);
end;

function tmainf.collection_chgok_chksave:bool;
var
  objok:bool;
  rc,r:integer;
begin
  result:=true;
  if not collection_chgok then exit;

  //any objects?
  objok:=false;
  for r:=0 to componentcount-1 do begin
    if not(components[r] is tmediap) then continue;
    objok:=true;
    break;
  end;
  if not objok then begin
    collection_chgok:=false;
    exit;
  end;

  rc:=application.MessageBox(
    pchar('Die (letzte) Kollektion wurde verndert. Jetzt speichern?'),
    '*** FRAGE ***',
    mb_yesnocancel
  );

  if rc=id_no then exit;
  if rc=id_cancel then begin
    result:=false;
    exit;
  end;
  collection_save1Click(nil);
end;

procedure tmainf.collection_save(fn:string);
var
  inif:tinifile;
  r,rr:integer;
  mp:tmediap;
  x,y:integer;
  mp_a_x,mp_a_y:integer;
begin
  screen.Cursor:=crhourglass;
  deletefile(fn);
  inif:=tinifile.create(fn);
  try
    rr:=0;
    for r:=componentcount-1 downto 0 do begin
      if not(components[r] is tmediap) then continue;
      mp:=tmediap(components[r]);
      inif.WriteString('mp'+inttostr(rr),'fn',mp.afn);
      inif.Writeinteger('mp'+inttostr(rr),'top',mp.top);
      inif.Writeinteger('mp'+inttostr(rr),'left',mp.left);
      inif.Writeinteger('mp'+inttostr(rr),'height',mp.height);
      inif.Writeinteger('mp'+inttostr(rr),'width',mp.width);

      //p in pa-array?
      mp_a_x:=-1;mp_a_y:=-1;
      for y:=0 to _mp_max do begin
        for x:=0 to _mp_max do begin
          if mp_a[x,y]=nil then continue;
          if mp_a[x,y]<>mp then continue;
          mp_a_x:=x;
          mp_a_y:=y;
          break;
        end;
      end;

      //array-pos speichern (wenn nicht, dann x,y=-1
      inif.Writeinteger('mp'+inttostr(rr),'mp_a_x',mp_a_x);
      inif.Writeinteger('mp'+inttostr(rr),'mp_a_y',mp_a_y);

      rr:=rr+1;
    end;

    info(
      'Ok, MediaPanelyzer-Kollektion '+_cr+_cr+
      '  '+fn+_cr+_cr+
      'gespeichert!'
    );
    collection_afn:=fn;
    collection_opendlg.initialdir:=extractfilepath(fn);
    collection_savedlg.initialdir:=extractfilepath(fn);
    collection_chgok:=false;
  finally
    inif.free;
    screen.Cursor:=crdefault;
  end;
end;

procedure Tmainf.collection_save1Click(Sender: TObject);
begin
  if collection_afn='' then
    collection_saveunder1click(sender)
  else
    collection_save(collection_afn);
end;

procedure Tmainf.collection_saveunder1Click(Sender: TObject);
var
  fn:string;
begin
  if collection_afn<>'' then
    collection_savedlg.filename:=collection_afn
  else
    collection_savedlg.filename:='collection.mpc';
  if not collection_savedlg.Execute then exit;
  fn:=collection_savedlg.filename;

  if fileexists(fn) then begin
    if application.messagebox(
      pchar('Datei "'+fn+'" existiert bereits. Wirklich berschreiben?'),
      '*** FRAGE ***',
      mb_yesno
    )=id_no then exit;
  end;

  collection_save(fn);
end;

{$R-}
{------------------------------------------------------------------
Baue optimierten collection_img_thumb.

ACHTUNG: Funktioniert nur, wenn bei Compiler-Optionen
         die Bereichsprfung deaktiviert ist!
-------------------------------------------------------------------}
procedure tmainf.collection_img_thumb(Src,Dst:TBitmap);
type
  // Contributor for a pixel
  TContributor=record
    pixel:integer;		// Source pixel
    weight:single;		// Pixel weight
  end;

  TContributorList=array[0..0] of TContributor;
  PContributorList=^TContributorList;

  // List of source pixels contributing to a destination pixel
  TCList=record
    n:integer;
    p:PContributorList;
  end;

  TCListList=array[0..0] of TCList;
  PCListList=^TCListList;

  TRGB=packed record
    r,g,b:single;
  end;

  // Physical bitmap pixel
  TColorRGB=packed record
    r,g,b:BYTE;
  end;
  PColorRGB=^TColorRGB;

  // Physical bitmap scanline (row)
  TRGBList=packed array[0..0] of TColorRGB;
  PRGBList=^TRGBList;

var
  xscale,yscale:single;		// Zoom scale factors
  i,j,k:integer;		// Loop variables
  center:single;		// Filter calculation variables
  width,fscale,weight:single;		// Filter calculation variables
  left,right:integer;		// Filter calculation variables
  n,cc,ccmod:integer;		// Pixel number
  Work:TBitmap;
  contrib:PCListList;
  rgb:TRGB;
  color:TColorRGB;
  SourceLine,
  DestLine:PRGBList;
  SourcePixel,
  DestPixel:PColorRGB;
  Delta,
  DestDelta:integer;
  SrcWidth,
  SrcHeight,
  DstWidth,
  DstHeight:integer;
  fwidth:single;

  function Color2RGB(Color: TColor): TColorRGB;
  begin
    Result.r:=Color AND $000000FF;
    Result.g:=(Color AND $0000FF00) SHR 8;
    Result.b:=(Color AND $00FF0000) SHR 16;
  end;

  function RGB2Color(Color: TColorRGB): TColor;
  begin
    Result:=Color.r OR (Color.g SHL 8) OR (Color.b SHL 16);
  end;

  function Lanczos3Filter(Value:Single):Single;

    function SinC(Value:Single):Single;
    begin
      if Value<>0.0 then begin
        Value:=Value*Pi;
        Result:=sin(Value)/Value;
      end
      else begin
        Result:=1.0;
      end;
    end;

  begin
    if Value<0.0 then Value:=-Value;
    if Value<3.0 then Result:=SinC(Value)*SinC(Value/3.0)
                 else Result:=0.0;
  end;

begin
  fwidth:=3.0;
  DstWidth:=Dst.Width;
  DstHeight:=Dst.Height;
  SrcWidth:=Src.Width;
  SrcHeight:=Src.Height;
  if (SrcWidth<1)or(SrcHeight<1) then
    raise Exception.Create('Source bitmap too small');

  // Create intermediate image to hold horizontal zoom
  Work:=TBitmap.Create;
  try
    Work.Height:=SrcHeight;
    Work.Width:=DstWidth;
    if SrcWidth=1 then xscale:=DstWidth/SrcWidth
                  else xscale:=(DstWidth-1)/(SrcWidth-1);
    if SrcHeight=1 then yscale:=DstHeight/SrcHeight
                   else yscale:=(DstHeight-1)/(SrcHeight-1);
    Src.PixelFormat:=pf24bit;
    Dst.PixelFormat:=Src.PixelFormat;
    Work.PixelFormat:=Src.PixelFormat;

    // --------------------------------------------
    // Pre-calculate filter contributions for a row
    // -----------------------------------------------
    GetMem(contrib,DstWidth*sizeof(TCList));

    // Horizontal sub-sampling
    // Scales from bigger to smaller width
    if xscale<1.0 then begin
      width:=fwidth/xscale;
      fscale:=1.0/xscale;

      for i:=0 to DstWidth-1 do begin

        contrib^[i].n:=0;
        GetMem(contrib^[i].p,trunc(width*2.0+1)*sizeof(TContributor));
        center:=i/xscale;
        // Original code:
        // left := ceil(center - width);
        // right := floor(center + width);
        left:=floor(center-width);
        right:=ceil(center+width);
        for j:=left to right do begin
          weight:=Lanczos3Filter((center-j)/fscale)/fscale;
          if weight=0.0 then continue;
          if      j<0         then n := -j
          else if j>=SrcWidth then n := SrcWidth - j + SrcWidth - 1
          else                     n := j;
          k:=contrib^[i].n;
          contrib^[i].n:=contrib^[i].n+1;

          //fliegt bei k=1 ab (0 geht noch) bei aktiver bereichsprfung
          //so gehts auch nicht: contrib[i].p[k].pixel:=n;

          contrib^[i].p^[k].pixel:=n;
          contrib^[i].p^[k].weight:=weight;
        end;
      end;
    end
    else begin
      // Horizontal super-sampling
      // Scales from smaller to bigger width
      for i:=0 to DstWidth-1 do begin

        contrib^[i].n:=0;
        GetMem(contrib^[i].p,trunc(fwidth*2.0+1)*sizeof(TContributor));
        center:=i/xscale;
        // Original code:
        // left := ceil(center - fwidth);
        // right := floor(center + fwidth);
        left:=floor(center-fwidth);
        right:=ceil(center+fwidth);
        for j:=left to right do begin
          weight:=Lanczos3Filter(center-j);
          if weight=0.0 then continue;
          if      j<0         then n:=-j
          else if j>=SrcWidth then n:=SrcWidth-j+SrcWidth-1
                              else n:=j;
          k:=contrib^[i].n;
          contrib^[i].n:=contrib^[i].n+1;
          contrib^[i].p^[k].pixel:=n;
          contrib^[i].p^[k].weight:=weight;
        end;
      end;
    end;

    // ----------------------------------------------------
    // Apply filter to sample horizontally from Src to Work
    // ----------------------------------------------------

    for k:=0 to SrcHeight-1 do begin

      SourceLine:=Src.ScanLine[k];
      DestPixel:=Work.ScanLine[k];
      for i:=0 to DstWidth-1 do begin
        rgb.r:=0.0;
        rgb.g:=0.0;
        rgb.b:=0.0;
        for j:=0 to contrib^[i].n-1 do begin
          color:=SourceLine^[contrib^[i].p^[j].pixel];
          weight:=contrib^[i].p^[j].weight;
          if weight=0.0 then continue;
          rgb.r:=rgb.r+color.r*weight;
          rgb.g:=rgb.g+color.g*weight;
          rgb.b:=rgb.b+color.b*weight;
        end;
        if      rgb.r>255 then color.r:=255
        else if rgb.r<0.0 then color.r:=0
        else                   color.r:=round(rgb.r);
        if      rgb.g>255 then color.g:=255
        else if rgb.g<0.0 then color.g:=0
        else                   color.g:=round(rgb.g);
        if      rgb.b>255 then color.b:=255
        else if rgb.b<0.0 then color.b:=0
        else                   color.b:=round(rgb.b);
        // Set new pixel value
        DestPixel^:=color;
        // Move on to next column
        inc(DestPixel);
      end;
    end;

    // Free the memory allocated for horizontal filter weights
    for i:=0 to DstWidth-1 do FreeMem(contrib^[i].p);
    FreeMem(contrib);

    // -----------------------------------------------
    // Pre-calculate filter contributions for a column
    // -----------------------------------------------
    GetMem(contrib,DstHeight*sizeof(TCList));
    // Vertical sub-sampling
    // Scales from bigger to smaller height
    if yscale<1.0 then begin
      width:=fwidth/yscale;
      fscale:=1.0/yscale;

      for i:=0 to DstHeight-1 do begin

        contrib^[i].n:=0;
        GetMem(contrib^[i].p,trunc(width*2.0+1)*sizeof(TContributor));
        center:=i/yscale;
        // Original code:
        // left := ceil(center - width);
        // right := floor(center + width);
        left:=floor(center-width);
        right:=ceil(center+width);
        for j:=left to right do begin
          weight:=Lanczos3Filter((center-j)/fscale)/fscale;
          if (weight = 0.0) then continue;
          if (j < 0) then n := -j
          else if (j >= SrcHeight) then n := SrcHeight - j + SrcHeight - 1
          else n := j;
          k := contrib^[i].n;
          contrib^[i].n := contrib^[i].n + 1;
          contrib^[i].p^[k].pixel := n;
          contrib^[i].p^[k].weight := weight;
        end;
      end
    end
    else begin
      // Vertical super-sampling
      // Scales from smaller to bigger height
      for i := 0 to DstHeight-1 do begin

        contrib^[i].n := 0;
        GetMem(contrib^[i].p, trunc(fwidth * 2.0 + 1) * sizeof(TContributor));
        center := i / yscale;
        // Original code:
        // left := ceil(center - fwidth);
        // right := floor(center + fwidth);
        left := floor(center - fwidth);
        right := ceil(center + fwidth);
        for j := left to right do begin
          weight := Lanczos3Filter(center - j);
          if (weight = 0.0) then continue;
          if (j < 0) then n := -j
          else if (j >= SrcHeight) then n := SrcHeight - j + SrcHeight - 1
          else n := j;
          k := contrib^[i].n;
          contrib^[i].n := contrib^[i].n + 1;
          contrib^[i].p^[k].pixel := n;
          contrib^[i].p^[k].weight := weight;
        end;
      end;
    end;

    // --------------------------------------------------
    // Apply filter to sample vertically from Work to Dst
    // --------------------------------------------------
    SourceLine := Work.ScanLine[0];
    Delta := integer(Work.ScanLine[1]) - integer(SourceLine);
    DestLine := Dst.ScanLine[0];
    DestDelta := integer(Dst.ScanLine[1]) - integer(DestLine);
    for k := 0 to DstWidth-1 do begin

      DestPixel := pointer(DestLine);
      for i := 0 to DstHeight-1 do begin
        rgb.r := 0;
        rgb.g := 0;
        rgb.b := 0;
        // weight := 0.0;
        for j := 0 to contrib^[i].n-1 do begin
          color := PColorRGB(integer(SourceLine)+contrib^[i].p^[j].pixel*Delta)^;
          weight := contrib^[i].p^[j].weight;
          if (weight = 0.0) then continue;
          rgb.r := rgb.r + color.r * weight;
          rgb.g := rgb.g + color.g * weight;
          rgb.b := rgb.b + color.b * weight;
        end;
        if (rgb.r > 255.0) then color.r := 255
        else if (rgb.r < 0.0) then color.r := 0
        else color.r := round(rgb.r);
        if (rgb.g > 255.0) then color.g := 255
        else if (rgb.g < 0.0) then color.g := 0
        else color.g := round(rgb.g);
        if (rgb.b > 255.0) then color.b := 255
        else if (rgb.b < 0.0) then color.b := 0
        else color.b := round(rgb.b);
        DestPixel^ := color;
        inc(integer(DestPixel), DestDelta);
      end;
      Inc(SourceLine,1);
      Inc(DestLine,1);
    end;

    // Free the memory allocated for vertical filter weights
    for i := 0 to DstHeight-1 do FreeMem(contrib^[i].p);
    FreeMem(contrib);

  finally
    Work.Free;
  end;
end;
{$R+}

procedure Tmainf.collection_img_make1Click(Sender: TObject);
var
  l,w,h,t,x,y,maxx,maxy,r:integer;
  fac:double;
  mp:tmediap;
  fn:string;
  jpg:tjpegimage;
  bmp_collection,
  bmp_media_org,
  bmp_media_thumb:tbitmap;
begin
  //check if there are movies
  for r:=componentcount-1 downto 0 do begin
    if not(components[r] is tmediap) then continue;
    mp:=tmediap(components[r]);
    if mp.movp=nil then continue;

    error(
      'Sorry, aber Datei '+_cr+_cr+
      '  '+mp.afn+_cr+_cr+
      'ist ein Movie.'+_cr+_cr+
      'Movies knnen nicht in die Collage integriert werden.'+_cr+
      'Verwenden Sie stattdessen "Screenshot generieren".'
    );
    exit;
  end;

  bmp_collection:=tbitmap.Create;
  bmp_collection.PixelFormat:=pf24bit;
  bmp_media_org:=tbitmap.Create;
  bmp_media_org.PixelFormat:=pf24bit;
  bmp_media_thumb:=tbitmap.Create;
  bmp_media_thumb.PixelFormat:=pf24bit;
  try
    maxx:=0;
    maxy:=0;
    for r:=0 to componentcount-1 do begin
      if not(components[r] is tmediap) then continue;
      mp:=tmediap(components[r]);
      x:=mp.left+mp.width;
      if x>maxx then maxx:=x;
      y:=mp.top+mp.height;
      if y>maxy then maxy:=y;
    end;

    coldimf.factor:=maxx/maxy;
    coldimf.width_se.Value:=maxx;
    coldimf.height_se.Value:=maxy;
    coldimf.ShowModal;
    if not coldimf.rc then exit;

    fac:=coldimf.width_se.Value*100/maxx;

    maxx:=coldimf.width_se.Value;
    maxy:=coldimf.height_se.Value;

    try
      bmp_collection.Width:=maxx;
      bmp_collection.height:=maxy;

      bmp_collection.canvas.brush.color:=canvas.brush.color;
      bmp_collection.canvas.FillRect(rect(0,0,maxx,maxy));

      for r:=0 to componentcount-1 do begin
        if not(components[r] is tmediap) then continue;
        mp:=tmediap(components[r]);

        l:=round(mp.Left*fac/100);
        t:=round(mp.top*fac/100);
        w:=round(mp.width*fac/100);
        h:=round(mp.height*fac/100);

        bmp_media_org.assign(mp.img.picture.graphic);

        bmp_media_thumb.width:=w;
        bmp_media_thumb.height:=h;
        collection_img_thumb(bmp_media_org,bmp_media_thumb);
        bitblt(
          bmp_collection.Canvas.Handle,l,t,w,h,
          bmp_media_thumb.Canvas.handle,0,0,
          srccopy
        );
      end;


      collection_img_savepicdlg.filename:=formatdatetime('mmdd',now)+'.jpg';
      if not collection_img_savepicdlg.execute then exit;
      fn:=collection_img_savepicdlg.FileName;
      collection_img_savepicdlg.initialdir:=extractfilepath(fn);

      jpg:=tjpegimage.create;
      try
        jpg.Assign(bmp_collection);

        jpg.CompressionQuality:=90;
        if fileexists(fn) then begin
          if application.messagebox(
            pchar('Datei "'+fn+'" existiert bereits. Wirklich berschreiben?'),
            '*** FRAGE ***',
            mb_yesno
          )=id_no then exit;
        end;
        jpg.SaveToFile(fn);
        object_open(fn);
      finally
        jpg.Free;
      end;
    except
    end;
  finally
    bmp_media_thumb.free;
    bmp_media_org.free;
    bmp_collection.Free;
  end;
end;

procedure Tmainf.collection_screenshot_make1Click(Sender: TObject);
var
  bmp:tbitmap;
  jpg:tjpegimage;
  fn:string;
  DeskTopDC:HDc;
  DeskTopCanvas:TCanvas;
  r,max_w,max_h:integer;
  mp:tmediap;
begin
  screen.Cursor:=crhourglass;

  //deactive active object
  sh_off;

  //deactivate hints, get max width and height
  max_w:=0;
  max_h:=0;
  for r:=0 to componentcount-1 do begin
    if components[r] is tmediap then begin
      mp:=tmediap(components[r]);
      mp.ShowHint:=false;
      if mp.Left+mp.width>max_w then max_w:=mp.Left+mp.width;
      if mp.top+mp.height>max_h then max_h:=mp.top+mp.height;
    end;
  end;
  if max_w>screen.Width then max_w:=screen.width;
  if max_h>screen.height then max_h:=screen.height;

  //make screenshot into bmp
  bmp:=tbitmap.Create;
  jpg:=tjpegimage.create;
  try
    DeskTopDC:=GetDC(Handle);
    DeskTopCanvas:=TCanvas.Create;
    try
      DeskTopCanvas.Handle:=DeskTopDC;
      bmp.width:=max_w;
      bmp.height:=max_h;
      bmp.Canvas.CopyRect(
        rect(0,0,max_w,max_h),
        DeskTopCanvas,
        rect(0,0,max_w,max_h)
      );
      ReleaseDC(GetDeskTopWindow,DeskTopDC);
    finally
      DeskTopCanvas.Free;
    end;

    //konvert to jpg
    jpg.Assign(bmp);
    screen.Cursor:=crdefault;

    //save jpg
    fn:=formatdatetime('yymmdd',now)+'.jpg';
    collection_img_savepicdlg.filename:=fn;
    if not collection_img_savepicdlg.execute then exit;
    fn:=collection_img_savepicdlg.filename;
    collection_img_savepicdlg.initialdir:=extractfilepath(fn);
    jpg.CompressionQuality:=90;
    if fileexists(fn) then
      if application.messagebox(
        pchar(
          'Datei "'+fn+'" existiert bereits.'+_cr+_cr+
          'Wirklich berschreiben?'
        ),
        '*** FRAGE ***',
        mb_yesno
      )=id_no then exit;
    jpg.SaveToFile(fn);

    //show jpg as new object
    object_open(fn);
  finally
    jpg.Free;
    bmp.free;
  end;
end;


//=== TMainF: Rest ========================================

procedure tmainf.history_go1click(sender:tobject);
var
  mi:tmenuitem;
begin
  mi:=tmenuitem(sender);
  object_open(mi.Hint);
end;

procedure Tmainf.about1Click(Sender: TObject);
begin
  application.MessageBox(_about,'*** MEDIAPANELYZER ***',mb_ok);
end;

procedure Tmainf.close1Click(Sender: TObject);
begin
  close;
end;

end.

